hdu6069 Counting Divisors lightoj1028 - Trailing Zeroes (I)

2023-12-26 02:38

本文主要是介绍hdu6069 Counting Divisors lightoj1028 - Trailing Zeroes (I),希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

由易到难:lightoj1028->hdu6069


lightoj1028 : http://www.lightoj.com/volume_showproblem.php?problem=1028

求一个数n,有多少种进制表示方法,使得末尾为0.

我们首先要想到这个n转化为其他进制如果末尾是0的话,只需要n可以整除这个数,换言之就是求n这个数在2-n范围内的约数。如果n很小的话(n<1e6)可以直接暴力遍历一次,但是n的范围是1e12,这个时候我们可以这样做。 n=px11px22px33... 其中 pi 是素数, xi 为正整数,这样我们就能算出约数的个数了。。。 
answer=(x1+1)(x2+1)...1

所以最后所求的就是打好一个1e6的素数表,然后用这个公式直接求就可以了。

(这里举一个例子):


所以2004的约数个数是ans=(2+1)*(1+1)*(1+1)=12; 最后减去1.因为没有1进制;

代码如下:

#include<bits/stdc++.h>
#define ll long long
using namespace std;const int N = 1e6+10;
ll prime[N];
ll num;void getPrime()
{memset(prime,0,sizeof(prime));//一开始prime都设为0代表都是素数(反向思考)for(int i=2;i<=N;i++){if(!prime[i])prime[++prime[0]]=i;for(int j=1;j<=prime[0]&&prime[j]<=N/i;j++){prime[prime[j]*i]=1;//prime[k]=1;k不是素数if(i%prime[j]==0)break;}}
}int main()
{getPrime();int T;int cas=1;scanf("%d",&T);ll n;while(T--){ll n ,temp,ans = 1;scanf("%lld",&n);for(int i = 1;(prime[i]*prime[i]<=n&&i<=prime[0]);i++){if(n%prime[i]==0){temp=0;while(n%prime[i]==0){temp++;n/=prime[i];}ans*=(temp+1);}}if(n>1) ans*=2;printf("Case %d: %lld\n",cas++,ans-1);  }
}

下面看一下hdu6069:http://acm.hdu.edu.cn/showproblem.php?pid=6069


所以还是一个对于n的分解问题,这里有一个用到的就是区间映射,从l到r拿0到r-l对应。中间遍历时先遍历素数表,假设现在遍历到prime[i],先找到l~r第一个能整除prime[i]的数a[j],以此开始,每次下标加prime[i],在分解a[j]时一直除以prime[i]直到除不尽,这时已经消除了prime[i]因子,把分解的幂值加进sum[j]。

代码如下:

#include<bits/stdc++.h>
#define ll long long 
#define mod 998244353
using namespace std;const int maxn = 1e6+10;
ll tot,t;  
ll l,r,k,ans,cnt[maxn],q[maxn],primes[maxn];
ll prime[maxn];void getPrime()
{memset(prime,0,sizeof(prime));//一开始prime都设为0代表都是素数(反向思考)for(ll i=2;i<=maxn;i++){if(!prime[i])prime[++prime[0]]=i;for(ll j=1;j<=prime[0]&&prime[j]<=maxn/i;j++){prime[prime[j]*i]=1;//prime[k]=1;k不是素数if(i%prime[j]==0)break;}}
}int main()
{getPrime();scanf("%d",&t);  while(t--){scanf("%lld%lld%lld",&l,&r,&k);ans = 0 ;if(l==1)	ans++,l++;for(ll i=0;i<=r-l;i++)	cnt[i]=1,q[i]=l+i;for(ll i=1;prime[i]*prime[i]<=r&&i<=prime[0];i++){ll j=l/prime[i]+(l%prime[i]!=0);for(j=j*prime[i];j<=r;j+=prime[i]){ll temp=0;while(q[j-l]%prime[i]==0) q[j-l]/=prime[i],temp++;cnt[j-l]*=(temp*k)%mod+1,cnt[j-l]%=mod; }} for(ll i=0;i<=r-l;i++){if(q[i]!=1)	ans+=((k+1)*cnt[i])%mod;else ans+=cnt[i];ans%=mod;}printf("%lld\n",ans);  }return 0;
}


这篇关于hdu6069 Counting Divisors lightoj1028 - Trailing Zeroes (I)的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/537838

相关文章

POJ 2386 Lake Counting(DFS)

题目: http://poj.org/problem?id=2386 题解: 遍历一次,遇到w,一次DFS后,与此w连接的所有w都被替换成‘ . ’,直到遍历完图中不再存在w为止,总共进行DFS的次数就是答案了。 代码: #include<stdio.h>int N,M;char map[110][110];void dfs(int x,int y){map[x][y]='

[LeetCode] 338. Counting Bits

题:https://leetcode.com/problems/counting-bits/description/ 题目 Given a non negative integer number num. For every numbers i in the range 0 ≤ i ≤ num calculate the number of 1’s in their binary repres

[LeetCode] 283. Move Zeroes

题:https://leetcode.com/problems/move-zeroes/submissions/1 题目 Given an array nums, write a function to move all 0’s to the end of it while maintaining the relative order of the non-zero elements. Ex

[LeetCode] 474. Ones and Zeroes

题:https://leetcode.com/problems/ones-and-zeroes/description/ 题目 In the computer world, use restricted resource you have to generate maximum benefit is what we always want to pursue. For now, suppos

《Zero-Shot Object Counting》CVPR2023

摘要 论文提出了一种新的计数设置,称为零样本对象计数(Zero-Shot Object Counting, ZSC),旨在测试时对任意类别的对象实例进行计数,而只需在测试时提供类别名称。现有的类无关计数方法需要人类标注的示例作为输入,这在许多实际应用中是不切实际的。ZSC方法不依赖于人类标注者,可以自动操作。研究者们提出了一种方法,可以从类别名称开始,准确识别出最佳的图像块(patches),用

Swift 3.0 学习 -- 计算字符数量 (Counting Characters)

在swift2.0的时候,可以通过调用全局countElements函数,并将字符串作为参数进行传递,可以获取该字符串的字符数量。如下: let unusualMenagerie = "Koala, Snail, Penguin, Dromedary"print("unusualMenagerie has \(countElements(unusualMenagerie)) charact

leetcode338 Counting Bits Java

Description Given a non negative integer number num. For every numbers i in the range 0 ≤ i ≤ num calculate the number of 1’s in their binary representation and return them as an array. Example: Fo

UVA 11401 Triangle Counting

中文详解请访问我的博客:http://xiaoshig.sinaapp.com/?p=128 You are given n rods of length 1, 2…, n. You have to pick any 3 of them & build a triangle. How many distinct triangles can you make? Note that, two

sdut2610--Boring Counting(二分+划分树)

Boring Counting Time Limit: 3000ms   Memory limit: 65536K  有疑问?点这里^_^ 题目描述     In this problem you are given a number sequence P consisting of N integer and Pi is the ith element in the

UVA - 11029Leading and Trailing(快速幂取模取后三位 + log10()取前三位)

题目: UVA - 11029Leading and Trailing(快速幂取模取后三位 + log10()取前三位) 题目大意:给你N的k次方,然后要求你求出这个数的前三位和后三位。 解题思路:因为n和k都很大,这个数求出来是大数,所以可以用快速幂取模求后三位,因为后面的三位和前面的位数的没有关系。前面的三位比较难办。设x = log (n^k)  = k * log10(n)